package br.uff.commerce.domain.customer;

import java.util.Map;

import br.uff.commerce.request.Request;
import br.uff.commerce.request.RequestException;

/**
 * Singleton
 *
 */
public class EditCustomerRequest implements Request
{
	public final static String NAME = "editCustomer";
	
	private static EditCustomerRequest soleInstance = null;
	
	public static EditCustomerRequest  getSoleInstance()
	{
		if (EditCustomerRequest.soleInstance == null)
			EditCustomerRequest.soleInstance = new EditCustomerRequest();
		
		return EditCustomerRequest.soleInstance;
	}
	
	private EditCustomerRequest() 
	{ 
		
	}

	@Override
	public void execute(Map<String, Object> parameters) throws RequestException
	{
		
		Long customerId = (Long) parameters.get("customerId");
		
		Customer subject = 
				CustomerRepository.getSoleInstance().findById(customerId);
		
		if (subject == null)
			throw new RequestException("Customer with id "+ 
		                                customerId +" not found.");
			
		subject.setName((String) parameters.get("name"));
		
		CustomerRepository.getSoleInstance().update(subject);
		
	}

}
