package br.uff.commerce.domain.product;

import java.util.Map;

import br.uff.commerce.request.Request;
import br.uff.commerce.request.RequestException;

/**
 * Singleton.
 *
 */
public class EditProductRequest implements Request
{
	public final static String NAME = "editProduct";
	
	private static EditProductRequest soleInstance = null;
	
	public static EditProductRequest  getSoleInstance()
	{
		if (EditProductRequest.soleInstance == null)
			EditProductRequest.soleInstance = new EditProductRequest();
		
		return EditProductRequest.soleInstance;
	}
	
	private EditProductRequest() 
	{ 
		
	}

	@Override
	public void execute(Map<String, Object> parameters) throws RequestException
	{
		
		Long productId = (Long) parameters.get("productId");
		
		Product subject = 
				ProductRepository.getSoleInstance().findById(productId);
		
		if (subject == null)
			throw new RequestException("Product with id "+ 
		                                productId +" not found.");
			
		subject.setName((String) parameters.get("name"));
		
		ProductRepository.getSoleInstance().update(subject);
		
	}

}
