package br.uff.commerce.requestprocessing;

import br.uff.commerce.domain.customer.EditCustomerRequest;
import br.uff.commerce.domain.product.EditProductRequest;
import br.uff.commerce.request.Request;

/**
 * Factory parametrizado e Singleton.
 *
 */
public class RequestFactory
{
	private static RequestFactory soleInstance = null;
	
	public static RequestFactory getSoleInstance()
	{
		if (RequestFactory.soleInstance == null)
			RequestFactory.soleInstance = new RequestFactory();
		
		return RequestFactory.soleInstance;
	}
	
	private RequestFactory() {}
	
	public Request createRequest(String requestName)
	{
		if (requestName == null || requestName.trim().isEmpty())
			throw new IllegalArgumentException("Request name is mandatory.");
		
		Request result;
		
		if (requestName.equals(EditProductRequest.NAME))
			result = EditProductRequest.getSoleInstance();
		else if (requestName.equals(EditCustomerRequest.NAME))
			result = EditCustomerRequest.getSoleInstance();
		else 
			throw new IllegalArgumentException(
					"Request object not found for "+ requestName);
			
		return result;
	}
	
}
